//------------------------------------------------------------------------------
// GPL LISENCE (short)
//------------------------------------------------------------------------------
/*
* Copyright (c) 2014 R1KO

* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.

* ChangeLog:
		1.0.0 -	Релиз
*/
#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <vip_core>

public Plugin:myinfo =
{
	name = "[VIP] C4 Model",
	author = "R1KO (skype: vova.andrienko1)",
	version = "1.0.0"
};

#define VIP_C4MODEL	"C4_Model"

new bool:g_bEnabled;

new Handle:g_hConVar_C4Model;
new String:g_sConVar_C4Model[PLATFORM_MAX_PATH];

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_C4MODEL, BOOL);
}

public OnPluginStart()
{
	g_hConVar_C4Model = CreateConVar("vip_c4_model", "models/weapons/w_c4_planted.mdl", "Модель бомбы", FCVAR_PLUGIN);
	GetConVarString(g_hConVar_C4Model, g_sConVar_C4Model, sizeof(g_sConVar_C4Model));
	HookConVarChange(g_hConVar_C4Model, OnConVarChange);
	
	AutoExecConfig(true, "VIP_C4_Model", "vip");
}

public OnConVarChange(Handle:hConVar, const String:sOldValue[], const String:sNewValue[])
{
	GetConVarString(g_hConVar_C4Model, g_sConVar_C4Model, sizeof(g_sConVar_C4Model));

	if(PrecacheModel(g_sConVar_C4Model, true) == 0)
	{
		LoadDefault();
	}
}

LoadDefault()
{
	strcopy(g_sConVar_C4Model, sizeof(g_sConVar_C4Model), "models/weapons/w_c4_planted.mdl");
	PrecacheModel(g_sConVar_C4Model, true);
}

public OnConfigsExecuted()
{
	if(PrecacheModel(g_sConVar_C4Model, true) == 0)
	{
		LoadDefault();
	}
}

public Event_BombPlanted(Handle:hEvent, const String:sEvName[], bool:bDontBroadcast)
{
	new iClient = GetClientOfUserId(GetEventInt(hEvent, "userid"));
	if(VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, VIP_C4MODEL))
	{
		new iEntity = FindEntityByClassname(-1, "planted_c4");
		if ( iEntity != -1 && IsValidEntity(iEntity))
		{
			SetEntityModel(iEntity, g_sConVar_C4Model);
		}
	}
}

public OnMapStart()
{
	g_bEnabled = (FindEntityByClassname(-1, "func_bomb_target") != -1);
	
	if(g_bEnabled)
	{
		HookEvent("bomb_planted", Event_BombPlanted);
	}
}

public OnMapEnd()
{
	if(g_bEnabled)
	{
		HookEvent("bomb_planted", Event_BombPlanted);
	}
}

